
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Rectangle;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.ListSelectionModel;
import javax.swing.SwingUtilities;
import javax.swing.border.BevelBorder;
import javax.swing.table.DefaultTableModel;

public class MainFrame extends JFrame {



    private static final long serialVersionUID = 1L;

    private JPanel jContentPane = null;

    private JButton jButtonAddAttribute = null;

    private JButton jButtonAddProperty = null;

    private JButton jButtonFinalize = null;

    private JButton jButtonSplit = null;

    private JPanel jPanelArdCreate = null;

    private JButton jButtonSave = null;

    private JScrollPane jScrollPaneArea = null;

    private JPanel jPanelAttribute = null;  //  @jve:decl-index=0:visual-constraint="933,-1"

    private JPanel jPanelProperty = null;  //  @jve:decl-index=0:visual-constraint="551,438"

    private JPanel jPanelFinalize = null;  //  @jve:decl-index=0:visual-constraint="867,160"

    private JPanel jPanelSplit = null;  //  @jve:decl-index=0:visual-constraint="16,537"

    private JTextField jTextAttribute = null;

    private JButton jButtonAttrOK = null;

    private JLabel jLabelAttr = null;

    private JLabel jLabelPropName = null;

    private JButton jButtonPropertyOk = null;

    private JComboBox jComboBox = null;

    private JLabel jLabelFinalizeProp = null;

    private JComboBox jComboFinalizeProp = null;

    private JButton jButtonMakeFinalize = null;

    private JScrollPane jScrollPaneFinalize = null;

    private JList jListAttribute = null;

    private JButton jButtonSaveXTT = null;

    private JComboBox jComboBoxSplitProp = null;


    private VardaControl varda = new VardaControl();  //  @jve:decl-index=0:

    //----------------split panel glowny-----------------------------------------
    private Vector<Vector<String>> 	attrData 	= null;
    private SplitData 				splitData 	= null;
    //---------------------------------------------------------------------------

    private String saveStr = new String("sar_file");  //  @jve:decl-index=0:


    private JButton jButtonPurge = null;

	private JPanel jPanelSplitAttr = null;  //  @jve:decl-index=0:visual-constraint="467,591"

	private JButton jButtonSplitAttrOk = null;

	private JButton jButtonSplitAttrCancel = null;

	private JButton jButtonSplitNewAttr = null;

	private JScrollPane jScrollPaneParam2 = null;

	private JList jListParam2 = null;

	private JComboBox jComboBoxSplitNewAttr = null;

	private JScrollPane jScrollPaneSplitAddAttr = null;

	private JList jListSplitNewAttr = null;

	private JButton jButtonSplitAddNewAttr = null;

	private JButton jButtonSplitRemNewAttr = null;

	private JButton jButtonNext = null;

	private JPanel jPanelSplitParam3 = null;  //  @jve:decl-index=0:visual-constraint="23,795"

	private JButton jButtonBeck = null;

	private JButton jButtonCreateSplit = null;

	private JScrollPane jScrollPaneParam3 = null;

	private JTable jTableParam3 = null;

	private JButton jButtonAddToParam3 = null;

	private JPanel jPanelEditProp = null;  //  @jve:decl-index=0:visual-constraint="479,835"

	private JTextField jTextFieldEditParam1 = null;

	private JTextField jTextFieldEditParam2 = null;

	private JLabel jLabelChoose = null;

	private JComboBox jComboBoxChooseProp = null;

	private JLabel jLabelFirstProp = null;

	private JLabel jLabelSecProp = null;

	private JButton jButtonAddParam3Ok = null;

	private JButton jButtonSplitAddProp = null;

	private JButton jButtonSplitAttrRemove = null;

	private JButton jButtonSplitReverse = null;

	private JButton jButtonKid = null;

	private JButton jButtonTph = null;

	private JButton jButtonArdTph = null;

	private JPanel jPanelSave = null;  //  @jve:decl-index=0:visual-constraint="941,780"

	private JButton jButtonSaveAll = null;

	private JRadioButton jRadioButtonArd = null;

	private JRadioButton jRadioButtonXtt = null;

	private JButton jButtonSavePanel = null;

	private JRadioButton jRadioButtonTph = null;

	private JRadioButton jRadioButtonArdTph = null;

	private JRadioButton jRadioButtonXml = null;

	private JRadioButton jRadioButtonXTTML2 = null;

	final JFileChooser fileChooser = new JFileChooser(System.getProperty("user.dir"));  //  @jve:decl-index=0:visual-constraint="841,431"

	private JButton jButtonOptimizeXtt = null;

	private JButton jButtonArdHistoryColl = null;

	private JButton jButtonTphArdHistoryColl = null;

	private JButton jButtonGenerateXtt = null;

	private JTextField jTextFieldSendTo = null;

	private JButton jButtonSend = null;

	private JLabel jLabelSend = null;

	/**
	 *
	 */
	private void refreshJPanelEdit(){
		getJTextFieldEditParam1().setText(splitData.getDataToEditPane().get(0));
		if(splitData.getDataToEditPane().size() == 2)
				getJTextFieldEditParam2().setText(splitData.getDataToEditPane().get(1));
		else
			getJTextFieldEditParam2().setText("");

		getJComboBoxChooseProp().removeAllItems();
		Vector<String> propVector = splitData.getAllProperysToSplit();
		for(int idx = 0; idx < propVector.size(); idx++){
			getJComboBoxChooseProp().addItem(propVector.get(idx));
		}

	}

	/**
	 *
	 */
	private void checkButtonSplitEnabled(){
		if(splitData == null)
			return;
		if(splitData.getSplitParam2().size() == 0){
			getJButtonNext().setEnabled(false);
		}
		else{
			getJButtonNext().setEnabled(true);
		}

	}

	/**
	 *
	 */
	private void refreshJTableParam3(){
		DefaultTableModel model = (DefaultTableModel)getJTableParam3().getModel();
		Vector<String> temp = new Vector<String>();

		temp.add("param 1");
		temp.add("param 2");

		model.setDataVector(splitData.getSplitParam3ToTable(), temp);
	}

	/**
	 * odswierza wszystkie elementy na panelu do rodzielanai atrybutow(JPanelSplitAttr)
	 */
	private void refreshJPanelSplitAttr(){
		//ustawienie combo
		getJComboBoxSplitNewAttr().removeAllItems();
		Vector<String> tempVect = splitData.getElementToCombo();
		for(int i = 0; i < tempVect.size(); i++){
			getJComboBoxSplitNewAttr().addItem(tempVect.get(i));
		}

		//ustawienie listy
		Vector<String> tempV = splitData.getTempVectorAttr();

		Vector<String> vect = new Vector<String>();
		getJListSplitNewAttr().setListData(vect); // dodane bo przy usuwaniue elementow cos sie wywallo
		if(tempV != null && tempV.size() != 0)
			getJListSplitNewAttr().setListData(tempV);

	}


	/**
	 * Pobiera aktualna spliData
	 * @return
	 */
	private SplitData getSplitData(){
		attrData = varda.getSplitableAttributes();
		int index = getJComboBoxSplitProp().getSelectedIndex();
		if(index == -1)
			index = 0;
		if(attrData.size() > 0){
			Vector<String> tempVect = attrData.get(index);
			if(tempVect.size() != 0)
				splitData = new SplitData(tempVect);
		}
		return splitData;
	}

	/**
	 *
	 */
	private void setButtonEnabled(){
        if(varda.getSplitableAttributes().size() == 0)
            getJButtonSplit().setEnabled(false);
        else
            getJButtonSplit().setEnabled(true);

        if(varda.getFinalizeAttr().size() == 0)
            getJButtonFinalize().setEnabled(false);
        else
            getJButtonFinalize().setEnabled(true);

        if(varda.getAttributesToMakeProp().size() == 0)
        	getJButtonAddProperty().setEnabled(false);
        else
        	getJButtonAddProperty().setEnabled(true);
    }


    /**
     *
     * @return
     */
    public Vector<Vector<String>> getSplitAttrData(){
    	attrData = varda.getSplitableAttributes();
        return attrData;
    }

    /**
     * This method initializes jButtonAddAttribute
     *
     * @return javax.swing.JButton
     */
    private JButton getJButtonAddAttribute() {
        if (jButtonAddAttribute == null) {
            jButtonAddAttribute = new JButton();
            jButtonAddAttribute.setText("Add Attribute");
            jButtonAddAttribute.setBounds(new Rectangle(15, 15, 132, 26));
            jButtonAddAttribute.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent e) {
                    addPanelToScrollPane(getJPanelAttribute());

                }
            });
        }
        return jButtonAddAttribute;
    }

    /**
     * This method initializes jButtonAddProperty
     *
     * @return javax.swing.JButton
     */
    private JButton getJButtonAddProperty() {
        if (jButtonAddProperty == null) {
            jButtonAddProperty = new JButton();
            jButtonAddProperty.setText("Add Property");
            jButtonAddProperty.setBounds(new Rectangle(15, 60, 132, 26));
            jButtonAddProperty.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent e) {
                    addPanelToScrollPane(getJPanelProperty());
                }
            });
        }
        return jButtonAddProperty;
    }

    /**
     * This method initializes jButtonFinalize
     *
     * @return javax.swing.JButton
     */
    private JButton getJButtonFinalize() {
        if (jButtonFinalize == null) {
            jButtonFinalize = new JButton();
            jButtonFinalize.setText("Finalize");
            jButtonFinalize.setBounds(new Rectangle(15, 105, 132, 26));
            jButtonFinalize.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent e) {
                    addPanelToScrollPane(getJPanelFinalize());
                }
            });
        }
        return jButtonFinalize;
    }

    /**
     * This method initializes jButtonSplit
     *
     * @return javax.swing.JButton
     */
    private JButton getJButtonSplit() {
        if (jButtonSplit == null) {
            jButtonSplit = new JButton();
            jButtonSplit.setText("Split");
            jButtonSplit.setBounds(new Rectangle(15, 150, 132, 26));
            jButtonSplit.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent e) {
                    addPanelToScrollPane(getJPanelSplit());
                }
            });
        }
        return jButtonSplit;
    }

    /**
     * This method initializes jPanelArdCreate
     *
     * @return javax.swing.JPanel
     */
    private JPanel getJPanelArdCreate() {
        if (jPanelArdCreate == null) {
            jPanelArdCreate = new JPanel();
            jPanelArdCreate.setLayout(null);
            jPanelArdCreate.setBounds(new Rectangle(14, 16, 604, 286));
            jPanelArdCreate.setForeground(new Color(51, 51, 100));
            jPanelArdCreate.setBackground(new Color(234, 239, 237));
            jPanelArdCreate.setBorder(BorderFactory.createBevelBorder(BevelBorder.RAISED));
            jPanelArdCreate.add(getJButtonAddAttribute(), null);
            jPanelArdCreate.add(getJButtonAddProperty(), null);
            jPanelArdCreate.add(getJButtonFinalize(), null);
            jPanelArdCreate.add(getJButtonSplit(), null);
            jPanelArdCreate.add(getJScrollPaneArea(), null);
            jPanelArdCreate.add(getJButtonSavePanel(), null);
        }
        return jPanelArdCreate;
    }

    /**
     * This method initializes jButtonSave
     *
     * @return javax.swing.JButton
     */
    private JButton getJButtonSave() {
        if (jButtonSave == null) {
            jButtonSave = new JButton();
            jButtonSave.setBounds(new Rectangle(15, 315, 121, 16));
            jButtonSave.setText("Show ard");
            jButtonSave.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent e) {
                    if(!varda.showArd())
                        JOptionPane.showMessageDialog(null, "Can not show Ard diagram");
                }
            });
        }
        return jButtonSave;
    }

    /**
     * This method initializes jScrollPaneArea
     *
     * @return javax.swing.JScrollPane
     */
    private JScrollPane getJScrollPaneArea() {
        if (jScrollPaneArea == null) {
            jScrollPaneArea = new JScrollPane();
            jScrollPaneArea.setBounds(new Rectangle(155, 6, 440, 272));
            jScrollPaneArea.setVisible(false);
        }
        return jScrollPaneArea;
    }

    private void addPanelToScrollPane(JPanel panel){
        getJScrollPaneArea().getViewport().add(panel);
        getJScrollPaneArea().setVisible(true);
    }

    /**
     * This method initializes jPanelAttribute
     *
     * @return javax.swing.JPanel
     */
    private JPanel getJPanelAttribute() {
        if (jPanelAttribute == null) {
            jLabelAttr = new JLabel();
            jLabelAttr.setBounds(new Rectangle(45, 30, 89, 17));
            jLabelAttr.setText("Attribute name");
            jPanelAttribute = new JPanel();
            jPanelAttribute.setLayout(null);
            jPanelAttribute.setSize(new Dimension(268, 129));
            jPanelAttribute.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
            jPanelAttribute.add(getJTextAttribute(), null);
            jPanelAttribute.add(getJButtonAttrOK(), null);
            jPanelAttribute.add(jLabelAttr, null);
        }
        return jPanelAttribute;
    }

    /**
     * This method initializes jPanelProperty
     *
     * @return javax.swing.JPanel
     */
    private JPanel getJPanelProperty() {
        if (jPanelProperty == null) {
            jLabelPropName = new JLabel();
            jLabelPropName.setBounds(new Rectangle(45, 30, 105, 17));
            jLabelPropName.setText("Propoerty name");
            jPanelProperty = new JPanel();
            jPanelProperty.setLayout(null);
            jPanelProperty.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
            jPanelProperty.setSize(new Dimension(270, 133));
            jPanelProperty.add(jLabelPropName, null);
            jPanelProperty.add(getJButtonPropertyOk(), null);
            jPanelProperty.add(getJComboBox(), null);
        }
        refreshComboBoxProp();
        return jPanelProperty;
    }

    /**
     * This method initializes jPanelFinalize
     *
     * @return javax.swing.JPanel
     */
    private JPanel getJPanelFinalize() {
        if (jPanelFinalize == null) {
            jLabelFinalizeProp = new JLabel();
            jLabelFinalizeProp.setBounds(new Rectangle(75, 15, 113, 17));
            jLabelFinalizeProp.setText("Property");
            jPanelFinalize = new JPanel();
            jPanelFinalize.setLayout(null);
            jPanelFinalize.setSize(new Dimension(336, 224));
            jPanelFinalize.add(jLabelFinalizeProp, null);
            jPanelFinalize.add(getJComboFinalizeProp(), null);
            jPanelFinalize.add(getJButtonMakeFinalize(), null);
            jPanelFinalize.add(getJScrollPaneFinalize(), null);
        }
        refreschFinalizePanel();
        return jPanelFinalize;
    }

    /**
     * This method initializes jPanelSplit
     *
     * @return javax.swing.JPanel
     */
    private JPanel getJPanelSplit() {
        if (jPanelSplit == null) {
            jPanelSplit = new JPanel();
            jPanelSplit.setLayout(null);
            jPanelSplit.setSize(new Dimension(424, 239));
            jPanelSplit.add(getJComboBoxSplitProp(), null);
            jPanelSplit.add(getJButtonSplitNewAttr(), null);
            jPanelSplit.add(getJScrollPaneParam2(), null);
            jPanelSplit.add(getJButtonNext(), null);
        }

        refreshSplitJComboAttr();
        getSplitData();
        refreshJListSplitParam2();
        checkButtonSplitEnabled();

        return jPanelSplit;
    }

    /**
     * This method initializes jTextAttribute
     *
     * @return javax.swing.JTextField
     */
    private JTextField getJTextAttribute() {
        if (jTextAttribute == null) {
            jTextAttribute = new JTextField();
            jTextAttribute.setBounds(new Rectangle(45, 45, 169, 25));
        }
        return jTextAttribute;
    }

    /**
     * This method initializes jButtonAttrOK
     *
     * @return javax.swing.JButton
     */
    private JButton getJButtonAttrOK() {
        if (jButtonAttrOK == null) {
            jButtonAttrOK = new JButton();
            jButtonAttrOK.setBounds(new Rectangle(103, 87, 57, 25));
            jButtonAttrOK.setText("OK");
            jButtonAttrOK.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent e) {
                    String attrName = getJTextAttribute().getText();

                    if(attrName.length() != 0){
                        if(!varda.addAttribute(attrName))
                            JOptionPane.showMessageDialog(null, "Error, can not add attribite");
                        else
                            JOptionPane.showMessageDialog(null, "Added attribute");
                    }

                    setButtonEnabled();
                }
            });
        }
        return jButtonAttrOK;
    }

    /**
     * This method initializes jButtonPropertyOk
     *
     * @return javax.swing.JButton
     */
    private JButton getJButtonPropertyOk() {
        if (jButtonPropertyOk == null) {
            jButtonPropertyOk = new JButton();
            jButtonPropertyOk.setBounds(new Rectangle(103, 87, 57, 25));
            jButtonPropertyOk.setText("OK");
            jButtonPropertyOk.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent e) {
                    boolean bVal = varda.addProperty((String)getJComboBox().getSelectedItem());
                    if(bVal)
                        JOptionPane.showMessageDialog(null, "Added property");
                    else
                        JOptionPane.showMessageDialog(null, "Error: can not add property");
                    refreshComboBoxProp();
                }
            });
        }
        return jButtonPropertyOk;
    }

    /**
     * This method initializes jComboBox
     *
     * @return javax.swing.JComboBox
     */
    private JComboBox getJComboBox() {
        if (jComboBox == null) {
            jComboBox = new JComboBox();
            jComboBox.setBounds(new Rectangle(45, 45, 169, 25));
        }
        return jComboBox;
    }

    /**
     *	This method refresches jComboBox in jPanelProperty
     */
    private void refreshComboBoxProp(){
        if(jComboBox != null){
            jComboBox.removeAllItems();
            Vector<String> attr = varda.getAttributesToMakeProp();
            for(int i = 0; i < attr.size(); i++){
                jComboBox.addItem(attr.get(i));
            }
        }
        setButtonEnabled();
    }

    /**
     * This method initializes jComboFinalizeProp
     *
     * @return javax.swing.JComboBox
     */
    private JComboBox getJComboFinalizeProp() {
        if (jComboFinalizeProp == null) {
            jComboFinalizeProp = new JComboBox();
            jComboFinalizeProp.setBounds(new Rectangle(75, 30, 181, 25));
        }
        return jComboFinalizeProp;
    }


    /**
     * This method initializes jButtonMakeFinalize
     *
     * @return javax.swing.JButton
     */
    private JButton getJButtonMakeFinalize() {
        if (jButtonMakeFinalize == null) {
            jButtonMakeFinalize = new JButton();
            jButtonMakeFinalize.setBounds(new Rectangle(135, 150, 57, 25));
            jButtonMakeFinalize.setText("OK");
            jButtonMakeFinalize.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent e) {
                    String strProperty = (String)getJComboFinalizeProp().getSelectedItem();
                    Object[] objAttributeTable = getJListAttribute().getSelectedValues();

                    //rzutowanie na z object stringa
                    String[] strAttributeTable = new String[objAttributeTable.length];

                    for(int i= 0; i < objAttributeTable.length; i++){
                        strAttributeTable[i] = (String)objAttributeTable[i];
                    }

                    if(strAttributeTable.length != 0){

                        if(varda.finalize(strProperty, strAttributeTable)){
                            JOptionPane.showMessageDialog(null, "Finalization complete");
                        }
                        else{
                            JOptionPane.showMessageDialog(null, "Can not make finalize");
                        }
                    }
                    refreschFinalizePanel();
                }

            });
        }
        return jButtonMakeFinalize;
    }

    /**
     *
     */
    private void refreschFinalizePanel(){
        if(jComboFinalizeProp != null){
            jComboFinalizeProp.removeAllItems();
            Vector<String> attrVector = varda.getFinalizeAttr();

            for(int i = 0; i < attrVector.size(); i++){
                jComboFinalizeProp.addItem(attrVector.get(i));
            }
        }

        if(jListAttribute != null){
            jListAttribute.removeAll();
            Vector<String> attrVector = varda.getFinalizableAttr();
            jListAttribute.setListData(attrVector);
        }
        setButtonEnabled();

    }

    /**
     * This method initializes jScrollPaneFinalize
     *
     * @return javax.swing.JScrollPane
     */
    private JScrollPane getJScrollPaneFinalize() {
        if (jScrollPaneFinalize == null) {
            jScrollPaneFinalize = new JScrollPane();
            jScrollPaneFinalize.setBounds(new Rectangle(75, 60, 181, 73));
            jScrollPaneFinalize.setViewportView(getJListAttribute());
        }
        return jScrollPaneFinalize;
    }

    /**
     * This method initializes jListAttribute
     *
     * @return javax.swing.JList
     */
    private JList getJListAttribute() {
        if (jListAttribute == null) {
            jListAttribute = new JList();
        }
        return jListAttribute;
    }

    /**
     * This method initializes jButtonSaveXTT
     *
     * @return javax.swing.JButton
     */
    private JButton getJButtonSaveXTT() {
        if (jButtonSaveXTT == null) {
            jButtonSaveXTT = new JButton();
            jButtonSaveXTT.setBounds(new Rectangle(165, 345, 110, 16));
            jButtonSaveXTT.setText("Show xtt");
            jButtonSaveXTT.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent e) {
                    if(!varda.showXTT())
                        JOptionPane.showMessageDialog(null, "Can not show  Xtt diagram");
                }
            });
        }
        return jButtonSaveXTT;
    }

    /**
     * This method initializes jComboBoxSplitProp
     *
     * @return javax.swing.JComboBox
     */
    private JComboBox getJComboBoxSplitProp() {
        if (jComboBoxSplitProp == null) {
            jComboBoxSplitProp = new JComboBox();
            jComboBoxSplitProp.setBounds(new Rectangle(30, 30, 286, 22));

            jComboBoxSplitProp.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent e) {
                	getSplitData();
                	refreshJListSplitParam2();
                	checkButtonSplitEnabled();
                }
            });
        }
        return jComboBoxSplitProp;
    }

    /**
     *
     */
    private void refreshJListSplitParam2(){

    	if(splitData == null)
    		return;

    	//wpisanie do listty, propertisy na ktore zostana rozdzielone propertisy podwojne
        Vector<String> vectList = new Vector<String>();
        Vector<Vector<String>> dataVect = splitData.getSplitParam2();
        for(int idx1 = 0; idx1 < dataVect.size(); idx1++){
            Vector<String> tempVect = dataVect.get(idx1);
            String strVal = new String("[");

            for(int idx2 = 0; idx2 < tempVect.size(); idx2++){
                strVal += tempVect.get(idx2);

                if(idx2 != tempVect.size() -1){
                    strVal += ", ";
                }
            }
            strVal += "]";
            vectList.add(strVal);
        }

        getJListParam2().removeAll();
        getJListParam2().setListData(vectList);

        //ustawienie przycisku na enalble lub disable -
        //w zaleznosci od tego czy sa inne mozliwosci rodzielenia propertisow (disable - jak propertys jest podwojny)
        if(splitData.getPropertysToSplit().size() == 2){
        	getJButtonSplitNewAttr().setEnabled(false);
        }
        else
        	getJButtonSplitNewAttr().setEnabled(true);
    }

    /**
     * This method initializes jButtonPurge
     *
     * @return javax.swing.JButton
     */
    private JButton getJButtonPurge() {
        if (jButtonPurge == null) {
            jButtonPurge = new JButton();
            jButtonPurge.setBounds(new Rectangle(498, 313, 106, 16));
            jButtonPurge.setText("Purge");
            jButtonPurge.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent e) {
                    int retVal = JOptionPane.showInternalOptionDialog(getJContentPane(),
                            "Chcesz usunac utworzony model ?",
                            "Message",
                            JOptionPane.YES_NO_CANCEL_OPTION,
                            JOptionPane.QUESTION_MESSAGE,
                            null,
                            new Object[]{"yes", "cancel"},
                            "yes");

                    if(retVal == 0){
                        varda.purgeModel();
                        setButtonEnabled();
                        addPanelToScrollPane(getJPanelAttribute());
                    }

                }
            });
        }
        return jButtonPurge;
    }

    /**
	 * This method initializes jPanelSplitAttr
	 *
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanelSplitAttr() {
		if (jPanelSplitAttr == null) {
			jPanelSplitAttr = new JPanel();
			jPanelSplitAttr.setLayout(null);
			jPanelSplitAttr.setSize(new Dimension(368, 236));
			jPanelSplitAttr.add(getJButtonSplitAttrOk(), null);
			jPanelSplitAttr.add(getJButtonSplitAttrCancel(), null);
			jPanelSplitAttr.add(getJComboBoxSplitNewAttr(), null);
			jPanelSplitAttr.add(getJScrollPaneSplitAddAttr(), null);
			jPanelSplitAttr.add(getJButtonSplitAddNewAttr(), null);
			jPanelSplitAttr.add(getJButtonSplitRemNewAttr(), null);
		}
		return jPanelSplitAttr;
	}

	/**
	 * This method initializes jButtonSplitAttrOk
	 *
	 * @return javax.swing.JButton
	 */
	private JButton getJButtonSplitAttrOk() {
		if (jButtonSplitAttrOk == null) {
			jButtonSplitAttrOk = new JButton();
			jButtonSplitAttrOk.setBounds(new Rectangle(135, 195, 106, 31));
			jButtonSplitAttrOk.setText("OK");
			jButtonSplitAttrOk.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					splitData.addToSplitParam2();
					addPanelToScrollPane(getJPanelSplit());
					refreshJListSplitParam2();
				}
			});
		}
		return jButtonSplitAttrOk;
	}

	/**
	 * This method initializes jButtonSplitAttrCancel
	 *
	 * @return javax.swing.JButton
	 */
	private JButton getJButtonSplitAttrCancel() {
		if (jButtonSplitAttrCancel == null) {
			jButtonSplitAttrCancel = new JButton();
			jButtonSplitAttrCancel.setBounds(new Rectangle(255, 195, 106, 31));
			jButtonSplitAttrCancel.setText("Cancel");
			jButtonSplitAttrCancel.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					addPanelToScrollPane(getJPanelSplit());
				}
			});
		}
		return jButtonSplitAttrCancel;
	}

	/**
	 * This method initializes jButtonSplitNewAttr
	 *
	 * @return javax.swing.JButton
	 */
	private JButton getJButtonSplitNewAttr() {
		if (jButtonSplitNewAttr == null) {
			jButtonSplitNewAttr = new JButton();
			jButtonSplitNewAttr.setBounds(new Rectangle(90, 60, 166, 31));
			jButtonSplitNewAttr.setText("Create new ");
			jButtonSplitNewAttr.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					addPanelToScrollPane(getJPanelSplitAttr());
					refreshJPanelSplitAttr();
				}
			});
		}
		return jButtonSplitNewAttr;
	}

	/**
	 * This method initializes jScrollPaneParam2
	 *
	 * @return javax.swing.JScrollPane
	 */
	private JScrollPane getJScrollPaneParam2() {
		if (jScrollPaneParam2 == null) {
			jScrollPaneParam2 = new JScrollPane();
			jScrollPaneParam2.setBounds(new Rectangle(15, 105, 316, 121));
			jScrollPaneParam2.setViewportView(getJListParam2());
		}
		return jScrollPaneParam2;
	}

	/**
	 * This method initializes jListParam2
	 *
	 * @return javax.swing.JList
	 */
	private JList getJListParam2() {
		if (jListParam2 == null) {
			jListParam2 = new JList();
		}
		return jListParam2;
	}

	/**
	 * This method initializes jComboBoxSplitNewAttr
	 *
	 * @return javax.swing.JComboBox
	 */
	private JComboBox getJComboBoxSplitNewAttr() {
		if (jComboBoxSplitNewAttr == null) {
			jComboBoxSplitNewAttr = new JComboBox();
			jComboBoxSplitNewAttr.setBounds(new Rectangle(30, 30, 151, 27));
		}
		return jComboBoxSplitNewAttr;
	}

	/**
	 * This method initializes jScrollPaneSplitAddAttr
	 *
	 * @return javax.swing.JScrollPane
	 */
	private JScrollPane getJScrollPaneSplitAddAttr() {
		if (jScrollPaneSplitAddAttr == null) {
			jScrollPaneSplitAddAttr = new JScrollPane();
			jScrollPaneSplitAddAttr.setBounds(new Rectangle(24, 88, 177, 97));
			jScrollPaneSplitAddAttr.setViewportView(getJListSplitNewAttr());
		}
		return jScrollPaneSplitAddAttr;
	}

	/**
	 * This method initializes jListSplitNewAttr
	 *
	 * @return javax.swing.JList
	 */
	private JList getJListSplitNewAttr() {
		if (jListSplitNewAttr == null) {
			jListSplitNewAttr = new JList();
		}
		return jListSplitNewAttr;
	}

	/**
	 * This method initializes jButtonSplitAddNewAttr
	 *
	 * @return javax.swing.JButton
	 */
	private JButton getJButtonSplitAddNewAttr() {
		if (jButtonSplitAddNewAttr == null) {
			jButtonSplitAddNewAttr = new JButton();
			jButtonSplitAddNewAttr.setBounds(new Rectangle(210, 30, 91, 27));
			jButtonSplitAddNewAttr.setText("Add");
			jButtonSplitAddNewAttr.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					String tempStr = new String();
					tempStr = (String)getJComboBoxSplitNewAttr().getSelectedItem();
					splitData.addToTempVector(tempStr);
					refreshJPanelSplitAttr();
				}
			});
		}
		return jButtonSplitAddNewAttr;
	}

	/**
	 * This method initializes jButtonSplitRemNewAttr
	 *
	 * @return javax.swing.JButton
	 */
	private JButton getJButtonSplitRemNewAttr() {
		if (jButtonSplitRemNewAttr == null) {
			jButtonSplitRemNewAttr = new JButton();
			jButtonSplitRemNewAttr.setBounds(new Rectangle(208, 88, 91, 25));
			jButtonSplitRemNewAttr.setText("Remove");
			jButtonSplitRemNewAttr.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					String strElem = (String)getJListSplitNewAttr().getSelectedValue();
					splitData.romveElementFromTempVector(strElem);
					refreshJPanelSplitAttr();
				}
			});
		}
		return jButtonSplitRemNewAttr;
	}

	/**
	 * This method initializes jButtonNext
	 *
	 * @return javax.swing.JButton
	 */
	private JButton getJButtonNext() {
		if (jButtonNext == null) {
			jButtonNext = new JButton();
			jButtonNext.setBounds(new Rectangle(345, 195, 61, 31));
			jButtonNext.setText("Next");
			jButtonNext.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					addPanelToScrollPane(getJPanelSplitParam3());
				}

			});
		}
		return jButtonNext;
	}


	/**
	 * This method initializes jPanelSplitParam3
	 *
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanelSplitParam3() {
		if (jPanelSplitParam3 == null) {
			jPanelSplitParam3 = new JPanel();
			jPanelSplitParam3.setLayout(null);
			jPanelSplitParam3.setSize(new Dimension(421, 262));
			jPanelSplitParam3.add(getJButtonBeck(), null);
			jPanelSplitParam3.add(getJButtonCreateSplit(), null);
			jPanelSplitParam3.add(getJScrollPaneParam3(), null);
			jPanelSplitParam3.add(getJButtonAddToParam3(), null);
		}
		refreshJTableParam3();
		return jPanelSplitParam3;
	}


	/**
	 * This method initializes jButtonBeck
	 *
	 * @return javax.swing.JButton
	 */
	private JButton getJButtonBeck() {
		if (jButtonBeck == null) {
			jButtonBeck = new JButton();
			jButtonBeck.setBounds(new Rectangle(15, 225, 76, 31));
			jButtonBeck.setText("Back");
			jButtonBeck.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					addPanelToScrollPane(getJPanelSplit());
				}
			});
		}
		return jButtonBeck;
	}


	/**
	 * This method initializes jButtonCreateSplit
	 *
	 * @return javax.swing.JButton
	 */
	private JButton getJButtonCreateSplit() {
		if (jButtonCreateSplit == null) {
			jButtonCreateSplit = new JButton();
			jButtonCreateSplit.setBounds(new Rectangle(330, 225, 76, 31));
			jButtonCreateSplit.setText("Split");
			jButtonCreateSplit.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					boolean ret = false;
					ret = varda.split(splitData);
					if(ret){
						JOptionPane.showMessageDialog(null, "Operation split completed");
						refreshSplitJComboAttr();
						addPanelToScrollPane(getJPanelSplit());

					}
					else{
						JOptionPane.showMessageDialog(null, "Can not make split operation");
					}
				}
			});
		}
		return jButtonCreateSplit;
	}


	/**
	 * This method initializes jScrollPaneParam3
	 *
	 * @return javax.swing.JScrollPane
	 */
	private JScrollPane getJScrollPaneParam3() {
		if (jScrollPaneParam3 == null) {
			jScrollPaneParam3 = new JScrollPane();
			jScrollPaneParam3.setBounds(new Rectangle(15, 15, 391, 151));
			jScrollPaneParam3.setViewportView(getJTableParam3());
		}
		return jScrollPaneParam3;
	}


	/**
	 * This method initializes jTableParam3
	 *
	 * @return javax.swing.JTable
	 */
	private JTable getJTableParam3() {
		if (jTableParam3 == null) {
			jTableParam3 = new JTable(new MyTableModel());
			jTableParam3.setRowSelectionAllowed(true);
			jTableParam3.setCellSelectionEnabled(true);
			jTableParam3.setColumnSelectionAllowed(false);
			jTableParam3.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		}
		return jTableParam3;
	}


	/**
	 * This method initializes jButtonAddToParam3
	 *
	 * @return javax.swing.JButton
	 */
	private JButton getJButtonAddToParam3() {
		if (jButtonAddToParam3 == null) {
			jButtonAddToParam3 = new JButton();
			jButtonAddToParam3.setBounds(new Rectangle(150, 180, 91, 16));
			jButtonAddToParam3.setText("Edit");
			jButtonAddToParam3.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					int index = getJTableParam3().getSelectedRow();
					if(index == -1)
						index = 0;
					splitData.setSelectedProperty(index);

					addPanelToScrollPane(getJPanelEditProp());
					refreshJPanelEdit();
				}
			});
		}
		return jButtonAddToParam3;
	}


	/**
	 * This method initializes jPanelEditProp
	 *
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanelEditProp() {
		if (jPanelEditProp == null) {
			jLabelSecProp = new JLabel();
			jLabelSecProp.setBounds(new Rectangle(30, 15, 136, 16));
			jLabelSecProp.setText("First propertys");
			jLabelFirstProp = new JLabel();
			jLabelFirstProp.setBounds(new Rectangle(30, 60, 136, 16));
			jLabelFirstProp.setText("Second propertys");
			jLabelChoose = new JLabel();
			jLabelChoose.setBounds(new Rectangle(30, 135, 172, 16));
			jLabelChoose.setText("Choose second porpertys");
			jPanelEditProp = new JPanel();
			jPanelEditProp.setLayout(null);
			jPanelEditProp.setSize(new Dimension(427, 256));
			jPanelEditProp.add(getJTextFieldEditParam1(), null);
			jPanelEditProp.add(getJTextFieldEditParam2(), null);
			jPanelEditProp.add(jLabelChoose, null);
			jPanelEditProp.add(getJComboBoxChooseProp(), null);
			jPanelEditProp.add(jLabelFirstProp, null);
			jPanelEditProp.add(jLabelSecProp, null);
			jPanelEditProp.add(getJButtonAddParam3Ok(), null);
			jPanelEditProp.add(getJButtonSplitAddProp(), null);
			jPanelEditProp.add(getJButtonSplitAttrRemove(), null);
			jPanelEditProp.add(getJButtonSplitReverse(), null);
		}
		return jPanelEditProp;
	}

	/**
	 * This method initializes jTextFieldEditParam1
	 *
	 * @return javax.swing.JTextField
	 */
	private JTextField getJTextFieldEditParam1() {
		if (jTextFieldEditParam1 == null) {
			jTextFieldEditParam1 = new JTextField();
			jTextFieldEditParam1.setBounds(new Rectangle(30, 30, 211, 31));
			jTextFieldEditParam1.setEditable(false);
		}
		return jTextFieldEditParam1;
	}

	/**
	 * This method initializes jTextFieldEditParam2
	 *
	 * @return javax.swing.JTextField
	 */
	private JTextField getJTextFieldEditParam2() {
		if (jTextFieldEditParam2 == null) {
			jTextFieldEditParam2 = new JTextField();
			jTextFieldEditParam2.setBounds(new Rectangle(30, 75, 211, 31));
			jTextFieldEditParam2.setEditable(false);
		}
		return jTextFieldEditParam2;
	}

	/**
	 * This method initializes jComboBoxChooseProp
	 *
	 * @return javax.swing.JComboBox
	 */
	private JComboBox getJComboBoxChooseProp() {
		if (jComboBoxChooseProp == null) {
			jComboBoxChooseProp = new JComboBox();
			jComboBoxChooseProp.setBounds(new Rectangle(30, 150, 211, 31));
		}
		return jComboBoxChooseProp;
	}

	/**
	 * This method initializes jButtonAddParam3Ok
	 *
	 * @return javax.swing.JButton
	 */
	private JButton getJButtonAddParam3Ok() {
		if (jButtonAddParam3Ok == null) {
			jButtonAddParam3Ok = new JButton();
			jButtonAddParam3Ok.setBounds(new Rectangle(150, 210, 121, 31));
			jButtonAddParam3Ok.setText("OK");
			jButtonAddParam3Ok.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					//TODO dodwaanie trzeciego parametru split
					addPanelToScrollPane(getJPanelSplitParam3());
				}
			});
		}
		return jButtonAddParam3Ok;
	}

	/**
	 * This method initializes jButtonSplitAddProp
	 *
	 * @return javax.swing.JButton
	 */
	private JButton getJButtonSplitAddProp() {
		if (jButtonSplitAddProp == null) {
			jButtonSplitAddProp = new JButton();
			jButtonSplitAddProp.setBounds(new Rectangle(286, 155, 106, 16));
			jButtonSplitAddProp.setText("Add");
			jButtonSplitAddProp.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					int nIdx = getJComboBoxChooseProp().getSelectedIndex();
					splitData.addToParam3(nIdx);
					refreshJPanelEdit();
				}
			});
		}
		return jButtonSplitAddProp;
	}

	/**
	 * This method initializes jButtonSplitAttrRemove
	 *
	 * @return javax.swing.JButton
	 */
	private JButton getJButtonSplitAttrRemove() {
		if (jButtonSplitAttrRemove == null) {
			jButtonSplitAttrRemove = new JButton();
			jButtonSplitAttrRemove.setBounds(new Rectangle(285, 89, 106, 16));
			jButtonSplitAttrRemove.setText("Remove");
			jButtonSplitAttrRemove.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					splitData.removeInParam3();
					refreshJPanelEdit();
				}
			});
		}
		return jButtonSplitAttrRemove;
	}

	/**
	 * This method initializes jButtonSplitReverse
	 *
	 * @return javax.swing.JButton
	 */
	private JButton getJButtonSplitReverse() {
		if (jButtonSplitReverse == null) {
			jButtonSplitReverse = new JButton();
			jButtonSplitReverse.setBounds(new Rectangle(286, 59, 106, 16));
			jButtonSplitReverse.setText("Reverse");
			jButtonSplitReverse.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					splitData.reverseAttr();
					refreshJPanelEdit();
				}
			});
		}
		return jButtonSplitReverse;
	}

	/**
	 * This method initializes jButtonKid
	 *
	 * @return javax.swing.JButton
	 */
	private JButton getJButtonKid() {
		if (jButtonKid == null) {
			jButtonKid = new JButton();
			jButtonKid.setBounds(new Rectangle(497, 344, 106, 16));
			jButtonKid.setText("Kill all disp");
			jButtonKid.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					int retVal = JOptionPane.showInternalOptionDialog(getJContentPane(),
                            "Chcesz zamknac wszystkie okna ?",
                            "Message",
                            JOptionPane.YES_NO_CANCEL_OPTION,
                            JOptionPane.QUESTION_MESSAGE,
                            null,
                            new Object[]{"yes", "cancel"},
                            "yes");

                    if(retVal == 0){
                        varda.killAllDisp();
                    }
				}

			});
		}
		return jButtonKid;
	}

	/**
	 * This method initializes jButtonArdHistory
	 *
	 * @return javax.swing.JButton
	 */
	private JButton getJButtonTph() {
		if (jButtonTph == null) {
			jButtonTph = new JButton();
			jButtonTph.setBounds(new Rectangle(165, 315, 111, 16));
			jButtonTph.setText("Show tph");
			jButtonTph.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
                    if(!varda.showTph())
                        JOptionPane.showMessageDialog(null, "Can not show TPH diagram");
				}
			});
		}
		return jButtonTph;
	}

	/**
	 * This method initializes jButtonArdTph
	 *
	 * @return javax.swing.JButton
	 */
	private JButton getJButtonArdTph() {
		if (jButtonArdTph == null) {
			jButtonArdTph = new JButton();
			jButtonArdTph.setBounds(new Rectangle(15, 345, 121, 16));
			jButtonArdTph.setText("Show ard/tph");
			jButtonArdTph.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
                    if(!varda.showTphArd())
                        JOptionPane.showMessageDialog(null, "Can not show  Ard/Tph diagram");
				}
			});
		}
		return jButtonArdTph;
	}

	/**
	 * This method initializes jPanelSave
	 *
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanelSave() {
		if (jPanelSave == null) {
			jLabelSend = new JLabel();
			jLabelSend.setBounds(new Rectangle(15, 135, 151, 16));
			jLabelSend.setText("Send to varda");
			jPanelSave = new JPanel();
			jPanelSave.setLayout(null);
			jPanelSave.setSize(new Dimension(431, 266));
			jPanelSave.add(getJButtonSaveAll(), null);
			jPanelSave.add(getJRadioButtonArd(), null);
			jPanelSave.add(getJRadioButtonXtt(), null);
			jPanelSave.add(getJRadioButtonTph(), null);
			jPanelSave.add(getJRadioButtonArdTph(), null);
			jPanelSave.add(getJRadioButtonXml(), null);
			jPanelSave.add(getJRadioButtonXTTML2(), null);
			jPanelSave.add(getJButtonOptimizeXtt(), null);
			jPanelSave.add(getJButtonArdHistoryColl(), null);
			jPanelSave.add(getJButtonTphArdHistoryColl(), null);
			jPanelSave.add(getJButtonGenerateXtt(), null);
			jPanelSave.add(getJTextFieldSendTo(), null);
			jPanelSave.add(getJButtonSend(), null);
			jPanelSave.add(jLabelSend, null);
			ButtonGroup group = new ButtonGroup();
			group.add(getJRadioButtonArd());
			group.add(getJRadioButtonArdTph());
			group.add(getJRadioButtonTph());
			group.add(getJRadioButtonXtt());
			group.add(getJRadioButtonXml());
			group.add(getJRadioButtonXTTML2());
		}
		return jPanelSave;
	}

	/**
	 * This method initializes jButtonSaveAll
	 *
	 * @return javax.swing.JButton
	 */
	private JButton getJButtonSaveAll() {
		if (jButtonSaveAll == null) {
			jButtonSaveAll = new JButton();
			jButtonSaveAll.setBounds(new Rectangle(165, 105, 106, 16));
			jButtonSaveAll.setText("Save");
			jButtonSaveAll.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					int retVal = fileChooser.showSaveDialog(null);

					if(retVal == JFileChooser.APPROVE_OPTION){
						fileChooser.getSelectedFile().getPath();
						if(varda.saveFile(saveStr, fileChooser.getSelectedFile().getPath())){
							JOptionPane.showMessageDialog(null, "File was saved");
						}
						else
							JOptionPane.showMessageDialog(null, "Can not save file");
					}
				}
			});
		}
		return jButtonSaveAll;
	}

	/**
	 * This method initializes jRadioButtonArd
	 *
	 * @return javax.swing.JRadioButton
	 */
	private JRadioButton getJRadioButtonArd() {
		if (jRadioButtonArd == null) {
			jRadioButtonArd = new JRadioButton();
			jRadioButtonArd.setBounds(new Rectangle(15, 15, 166, 16));
			jRadioButtonArd.setText("Save ard diagram");
			jRadioButtonArd.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					saveStr = "sar_file";
				}
			});
		}
		return jRadioButtonArd;
	}

	/**
	 * This method initializes jRadioButtonXtt
	 *
	 * @return javax.swing.JRadioButton
	 */
	private JRadioButton getJRadioButtonXtt() {
		if (jRadioButtonXtt == null) {
			jRadioButtonXtt = new JRadioButton();
			jRadioButtonXtt.setBounds(new Rectangle(225, 15, 151, 16));
			jRadioButtonXtt.setText("Save xtt diagram");
			jRadioButtonXtt.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					saveStr = "sxt_file";
				}
			});
		}
		return jRadioButtonXtt;
	}

	/**
	 * This method initializes jButtonSavePanel
	 *
	 * @return javax.swing.JButton
	 */
	private JButton getJButtonSavePanel() {
		if (jButtonSavePanel == null) {
			jButtonSavePanel = new JButton();
			jButtonSavePanel.setBounds(new Rectangle(15, 195, 132, 26));
			jButtonSavePanel.setText("Option");
			jButtonSavePanel.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					addPanelToScrollPane(getJPanelSave());
				}
			});
		}
		return jButtonSavePanel;
	}

	/**
	 * This method initializes jRadioButtonTph
	 *
	 * @return javax.swing.JRadioButton
	 */
	private JRadioButton getJRadioButtonTph() {
		if (jRadioButtonTph == null) {
			jRadioButtonTph = new JRadioButton();
			jRadioButtonTph.setBounds(new Rectangle(15, 45, 151, 16));
			jRadioButtonTph.setText("Save tph diagram");
			jRadioButtonTph.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					saveStr = "shi_file";
				}
			});
		}
		return jRadioButtonTph;
	}

	/**
	 * This method initializes jRadioButtonArdTph
	 *
	 * @return javax.swing.JRadioButton
	 */
	private JRadioButton getJRadioButtonArdTph() {
		if (jRadioButtonArdTph == null) {
			jRadioButtonArdTph = new JRadioButton();
			jRadioButtonArdTph.setBounds(new Rectangle(15, 75, 168, 16));
			jRadioButtonArdTph.setText("Save ard/tph diagram");
			jRadioButtonArdTph.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					saveStr = "sha_file";
				}
			});
		}
		return jRadioButtonArdTph;
	}

	/**
	 * This method initializes jRadioButtonXml
	 *
	 * @return javax.swing.JRadioButton
	 */
	private JRadioButton getJRadioButtonXml() {
		if (jRadioButtonXml == null) {
			jRadioButtonXml = new JRadioButton();
			jRadioButtonXml.setBounds(new Rectangle(225, 45, 166, 16));
			jRadioButtonXml.setText("Save model in XML");
			jRadioButtonXml.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					saveStr = "axg_file";
				}
			});
		}
		return jRadioButtonXml;
	}

	/**
	 * This method initializes jRadioButtonXTTML2
	 *
	 * @return javax.swing.JRadioButton
	 */
	private JRadioButton getJRadioButtonXTTML2() {
		if (jRadioButtonXTTML2 == null) {
			jRadioButtonXTTML2 = new JRadioButton();
			jRadioButtonXTTML2.setBounds(new Rectangle(225, 75, 181, 16));
			jRadioButtonXTTML2.setText("Sacve model in XTTML2.0");
			jRadioButtonXTTML2.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					saveStr = "xxg_file";
				}
			});
		}
		return jRadioButtonXTTML2;
	}

	/**
	 * This method initializes jButtonOptimizeXtt
	 *
	 * @return javax.swing.JButton
	 */
	private JButton getJButtonOptimizeXtt() {
		if (jButtonOptimizeXtt == null) {
			jButtonOptimizeXtt = new JButton();
			jButtonOptimizeXtt.setBounds(new Rectangle(15, 240, 136, 16));
			jButtonOptimizeXtt.setText("Optimize xtt");
			jButtonOptimizeXtt.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					if(varda.otherOption(VardaControl.eOption.eOptionOptimizeXtt)){
						JOptionPane.showMessageDialog(null, "Optimization compelete");
					}
					else
						JOptionPane.showMessageDialog(null, "Can not optimazie xtt");

				}
			});
		}
		return jButtonOptimizeXtt;
	}

	/**
	 * This method initializes jButtonArdHistoryColl
	 *
	 * @return javax.swing.JButton
	 */
	private JButton getJButtonArdHistoryColl() {
		if (jButtonArdHistoryColl == null) {
			jButtonArdHistoryColl = new JButton();
			jButtonArdHistoryColl.setBounds(new Rectangle(210, 210, 196, 16));
			jButtonArdHistoryColl.setText("Collapse Ard History");
			jButtonArdHistoryColl.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					if(varda.otherOption(VardaControl.eOption.eOptionArdCollapse)){
						JOptionPane.showMessageDialog(null, "Operation compeleted");
					}
					else
						JOptionPane.showMessageDialog(null, "Can not make operation");

				}
			});
		}
		return jButtonArdHistoryColl;
	}

	/**
	 * This method initializes jButtonTphArdHistoryColl
	 *
	 * @return javax.swing.JButton
	 */
	private JButton getJButtonTphArdHistoryColl() {
		if (jButtonTphArdHistoryColl == null) {
			jButtonTphArdHistoryColl = new JButton();
			jButtonTphArdHistoryColl.setBounds(new Rectangle(210, 240, 196, 16));
			jButtonTphArdHistoryColl.setText("Collapse ard/tph history");
			jButtonTphArdHistoryColl.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					if(varda.otherOption(VardaControl.eOption.eOptionArdTphCollapse)){
						JOptionPane.showMessageDialog(null, "Operation complete");
					}
					else
						JOptionPane.showMessageDialog(null, "Can not make operation");
				}
			});
		}
		return jButtonTphArdHistoryColl;
	}

	/**
	 * This method initializes jButtonGenerateXtt
	 *
	 * @return javax.swing.JButton
	 */
	private JButton getJButtonGenerateXtt() {
		if (jButtonGenerateXtt == null) {
			jButtonGenerateXtt = new JButton();
			jButtonGenerateXtt.setBounds(new Rectangle(15, 210, 136, 16));
			jButtonGenerateXtt.setText("Generate xtt");
			jButtonGenerateXtt.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					if(varda.otherOption(VardaControl.eOption.eOptionGenerateXtt)){
						JOptionPane.showMessageDialog(null, "Xtt diagram was generated");
					}
					else
						JOptionPane.showMessageDialog(null, "Can not generate Xtt diagram");
				}
			});
		}
		return jButtonGenerateXtt;
	}

	/**
	 * This method initializes jTextFieldSendTo
	 *
	 * @return javax.swing.JTextField
	 */
	private JTextField getJTextFieldSendTo() {
		if (jTextFieldSendTo == null) {
			jTextFieldSendTo = new JTextField();
			jTextFieldSendTo.setBounds(new Rectangle(11, 149, 241, 23));
		}
		return jTextFieldSendTo;
	}

	/**
	 * This method initializes jButtonSend
	 *
	 * @return javax.swing.JButton
	 */
	private JButton getJButtonSend() {
		if (jButtonSend == null) {
			jButtonSend = new JButton();
			jButtonSend.setBounds(new Rectangle(270, 150, 76, 16));
			jButtonSend.setText("Send");
			jButtonSend.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					String str = getJTextFieldSendTo().getText();
					if(varda.userQuery(str))
						JOptionPane.showMessageDialog(null, "Operation complete");
					else
						JOptionPane.showMessageDialog(null, "Can not make operation");
				}
			});
		}
		return jButtonSend;
	}

	/**
     * @param args
     */
    public static void main(String[] args) {
        SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                MainFrame thisClass = new MainFrame();
                thisClass.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
                thisClass.setVisible(true);
            }
        });
    }

    /**
     * This is the default constructor
     */
    public MainFrame() {
        super();
        initialize();


    }

    /**
     * This method initializes this
     *
     * @return void
     */
    private void initialize() {
        this.setContentPane(getJContentPane());
        this.setTitle("VARDA");
        this.setBounds(new Rectangle(300, 300, 633, 408));
        varda.initVarda();
        setButtonEnabled();
        setResizable(false);
    }

    /**
     * This method initializes jContentPane
     *
     * @return javax.swing.JPanel
     */
    private JPanel getJContentPane() {
        if (jContentPane == null) {
            jContentPane = new JPanel();
            jContentPane.setLayout(null);
            jContentPane.add(getJPanelArdCreate(), null);
            jContentPane.add(getJButtonSave(), null);
            jContentPane.add(getJButtonSaveXTT(), null);
            jContentPane.add(getJButtonPurge(), null);
            jContentPane.add(getJButtonKid(), null);
            jContentPane.add(getJButtonTph(), null);
            jContentPane.add(getJButtonArdTph(), null);
        }
        return jContentPane;
    }

    /**
     *
     */
    private void refreshSplitJComboAttr(){
    	getSplitAttrData();
    	getJComboBoxSplitProp().removeAllItems();
        for(int idx1 = 0; idx1 < attrData.size(); idx1++){

            String listItem = new String("[");
            int sizeTmp = attrData.get(idx1).size();
            for(int idx2 = 0; idx2 < sizeTmp; idx2++){
                listItem += attrData.get(idx1).get(idx2);

                if(idx2 != sizeTmp - 1){
                    listItem += ", ";
                }
            }
            listItem += "]";
            getJComboBoxSplitProp().addItem(listItem);
        }
    }
}  //  @jve:decl-index=0:visual-constraint="86,9"
