

import java.util.Vector;

/**
 * @author Damian Janicki
 *
 */
public class SplitData {

	private Vector<String> 			propertysToSplit 	= new Vector<String>(); 				// param1 to split
	private Vector<Vector<String>> 	splitParam2			= new Vector<Vector<String>>(); 		// param2 to split

	private Vector<Vector<Vector<String>>> splitParam3 	= new Vector<Vector<Vector<String>>>(); // param3 to split


	/**
	 * tymczasowy wektor uzywany przy towrzeniu nowych atrybutow(propertisow)
	 */
	private Vector<String> 		tempVectorAttr = new Vector<String>();


	/**
	 * tymczasowy vector propertysow uzywany przy towrzeniu trzeciego parametro split
	 */
	private Vector<Vector<String>> tempVectorProperty = null;

	private int selectedProperty = 0;

	/**
	 * @param strVectAttr
	 */
	SplitData(Vector<String> strVectAttr){
		propertysToSplit = strVectAttr;
		if(propertysToSplit.size() == 2){
			Vector<String> newAttr1 = new Vector<String>();
			Vector<String> newAttr2 = new Vector<String>();

			//dodanie elementow do drugiej listy  jako (durgi parametr split)
			newAttr1.add(propertysToSplit.get(0));
			newAttr2.add(propertysToSplit.get(1));
			splitParam2.add(newAttr1);
			splitParam2.add(newAttr2);

			//dodanie tych samych elementow do trzeciej listy
			splitParam3.removeAllElements();

			for(int i = 0; i < splitParam2.size(); i++){
				Vector<Vector<String>> newVect = new Vector<Vector<String>>();
				newVect.add(splitParam2.get(i));
				splitParam3.add(newVect);
			}
 		}
	}

	/**
	 * @return
	 */
	public int getSelectedProperty() {
		return selectedProperty;
	}

	/**
	 * @param selectedProperty
	 */
	public void setSelectedProperty(int selectedProperty) {
		this.selectedProperty = selectedProperty;
	}

	/**
	 * @param index - parametr ktory nalezy dodac jest zczytywany z tablicy vectora temp,
	 */
	public void addToParam3(int index){
		Vector<String> vectProperty = tempVectorProperty.get(index);

		//dodanie nowego atrybutu
		if(splitParam3.get(selectedProperty).size() == 2)
			splitParam3.get(selectedProperty).remove(1);
		splitParam3.get(selectedProperty).add(1, vectProperty);

	}

	/**
	 *
	 */
	public void removeInParam3(){
		if(splitParam3.get(selectedProperty).size() == 2)
			splitParam3.get(selectedProperty).remove(1);
	}

	/**
	 *
	 */
	public void reverseAttr(){
		Vector<Vector<String>> pairPropertys = splitParam3.get(selectedProperty);
		if(pairPropertys.size() == 2){

			Vector<String> param1 = pairPropertys.get(0);
			Vector<String> param2 = pairPropertys.get(1);

			pairPropertys.removeAllElements();

			pairPropertys.add(param2);
			pairPropertys.add(param1);
		}
	}

	/**
	 * @return
	 */
	public Vector<String> getDataToEditPane(){
		Vector<String> retVector = new Vector<String>();
		Vector<Vector<String>> tempVector = splitParam3.get(selectedProperty);

		String strVal1 = getStringFromVect(tempVector.get(0));
		retVector.add(strVal1);

		if(tempVector.size() == 2){
			String strVal2 = getStringFromVect(tempVector.get(1));
			retVector.add(strVal2);
		}
		return retVector;
	}

	/**
	 *  dodaje wector tymczasowych atrybutow do listy parametrow operacji split
	 */
	public void addToSplitParam2(){
		if(tempVectorAttr.size() != 0){
			Vector<String> clone = (Vector<String>)tempVectorAttr.clone();
			splitParam2.add(clone);
			tempVectorAttr.removeAllElements();

			//dodanie tych samych elementow do trzeciej listy
			splitParam3.removeAllElements();

			for(int i = 0; i < splitParam2.size(); i++){
				Vector<Vector<String>> newVect = new Vector<Vector<String>>();
				newVect.add(splitParam2.get(i));
				splitParam3.add(newVect);
			}
		}
	}

	/**
	 * zwraca tablice ktora bedzie wyswietlana w tabelce
	 * @return
	 */
	public Vector<Vector<String>> getSplitParam3ToTable(){
		Vector<Vector<String>> retVal = new Vector<Vector<String>>();

		for(int idx1 = 0; idx1 < splitParam3.size(); idx1++){
			Vector<String> vectToAdd = new Vector<String>();
			Vector<Vector<String>> tempDouble = splitParam3.get(idx1);

			for(int idx2 = 0; idx2 < tempDouble.size(); idx2++){
				vectToAdd.add(getStringFromVect(tempDouble.get(idx2)));
			}
			retVal.add(vectToAdd);
		}

		return retVal;
	}


	/**
	 * @param str
	 * @return
	 */
	private String getStringFromVect(Vector<String> str){
		String strToAdd = new String("[");

		for(int idx3 = 0; idx3 < str.size(); idx3++ ){
			strToAdd += str.get(idx3);

			if(idx3 != str.size() - 1)
				strToAdd += ", ";
		}
		strToAdd += "]";

		return strToAdd;
	}
	/**
	 * dodaje atrybut do listy tymczasowych atrybutow
	 * @param str
	 */
	public void addToTempVector(String str){
		tempVectorAttr.add(str);
	}


	/**
	 * @param idxElem
	 */
	public void romveElementFromTempVector(int idxElem){
		if(tempVectorAttr.size() > idxElem){
			tempVectorAttr.remove(idxElem);
		}
	}

	/**
	 * @param strElem
	 */
	public void romveElementFromTempVector(String strElem){
			tempVectorAttr.remove(strElem);
	}


	/**
	 * Zwraca liste atrybutow ktore sa wyswietlane w comboboxie
	 * @return
	 */
	public Vector<String> getElementToCombo(){
		Vector<String> retVector = (Vector<String>) propertysToSplit.clone();

		for(int i = 0; i < tempVectorAttr.size(); i++){
			retVector.remove(tempVectorAttr.elementAt(i));
		}
		return retVector;
	}

	/**
	 * @return
	 */
	public Vector<Vector<String>> getSplitParam2() {
		return splitParam2;
	}

	/**
	 * @param splitParam2
	 */
	public void setSplitParam2(Vector<Vector<String>> splitParam2) {
		this.splitParam2 = splitParam2;
	}

	/**
	 *
	 */
	private void getTempVectorPropertys(){
		tempVectorProperty = VardaControl.getPropertys();

		for(int i = 0; i < splitParam2.size(); i++){
			if(i != selectedProperty)
				tempVectorProperty.add(splitParam2.get(i));
		}
	}

	/**
	 * @return
	 */
	public Vector<String> getAllProperysToSplit(){
		getTempVectorPropertys(); //!!!!
		Vector<String> strPropVector = new Vector<String>();

		for(int idx = 0; idx < tempVectorProperty.size(); idx++){
			String tempStr = getStringFromVect(tempVectorProperty.get(idx));
			strPropVector.add(tempStr);
		}

		return strPropVector;
	}

	/**
	 * @return
	 */
	public Vector<Vector<Vector<String>>> getSplitParam3() {
		return splitParam3;
	}

	/**
	 * @param splitParam3
	 */
	public void setSplitParam3(Vector<Vector<Vector<String>>> splitParam3) {
		this.splitParam3 = splitParam3;
	}

	/**
	 * @return
	 */
	public Vector<String> getTempVectorAttr() {
		return tempVectorAttr;
	}

	/**
	 * @param tempVectorAttr
	 */
	public void setTempVectorAttr(Vector<String> tempVectorAttr) {
		this.tempVectorAttr = tempVectorAttr;
	}

	/**
	 * @return
	 */
	public Vector<String> getPropertysToSplit() {
		return propertysToSplit;
	}

	/**
	 * @param propertysToSplit
	 */
	public void setPropertysToSplit(Vector<String> propertysToSplit) {
		this.propertysToSplit = propertysToSplit;
	}

	public int getSizeSplitParam3(){
		int size = 0;

		for(int i = 0;i < splitParam3.size(); i++){
			if(splitParam3.get(i).size() == 2){
				size++;
			}
		}
		return size;
	}
}
